-- MySQL Administrator dump 1.4
--
-- ------------------------------------------------------
-- Server version	5.1.41-3ubuntu12.6


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;


--
-- Create schema mydb
--

CREATE DATABASE IF NOT EXISTS mydb;
USE mydb;

--
-- Definition of table `mydb`.`Aluno`
--

DROP TABLE IF EXISTS `mydb`.`Aluno`;
CREATE TABLE  `mydb`.`Aluno` (
  `aID` int(11) NOT NULL AUTO_INCREMENT,
  `aNome` varchar(45) NOT NULL,
  `aCpf` varchar(45) NOT NULL,
  PRIMARY KEY (`aID`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `mydb`.`Aluno`
--

/*!40000 ALTER TABLE `Aluno` DISABLE KEYS */;
LOCK TABLES `Aluno` WRITE;
INSERT INTO `mydb`.`Aluno` VALUES  (1,'jackson','3333'),
 (2,'teste','345'),
 (3,'jones','65432877654'),
 (4,'pedro','65499977654'),
 (5,'paulo','65499900004'),
 (6,'jose','65499909984'),
 (7,'ricardo','98799909984'),
 (8,'maria','987234909984'),
 (9,'teste','123456');
UNLOCK TABLES;
/*!40000 ALTER TABLE `Aluno` ENABLE KEYS */;


--
-- Definition of table `mydb`.`Cidade`
--

DROP TABLE IF EXISTS `mydb`.`Cidade`;
CREATE TABLE  `mydb`.`Cidade` (
  `ciID` int(11) NOT NULL AUTO_INCREMENT,
  `ciNome` varchar(45) NOT NULL,
  `ciEstado_eID` int(11) NOT NULL,
  PRIMARY KEY (`ciID`),
  KEY `fk_Cidade_Estado1` (`ciEstado_eID`),
  CONSTRAINT `fk_Cidade_Estado1` FOREIGN KEY (`ciEstado_eID`) REFERENCES `Estado` (`eID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `mydb`.`Cidade`
--

/*!40000 ALTER TABLE `Cidade` DISABLE KEYS */;
LOCK TABLES `Cidade` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `Cidade` ENABLE KEYS */;


--
-- Definition of table `mydb`.`Disciplina`
--

DROP TABLE IF EXISTS `mydb`.`Disciplina`;
CREATE TABLE  `mydb`.`Disciplina` (
  `dID` int(11) NOT NULL AUTO_INCREMENT,
  `dNome` varchar(45) NOT NULL,
  PRIMARY KEY (`dID`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `mydb`.`Disciplina`
--

/*!40000 ALTER TABLE `Disciplina` DISABLE KEYS */;
LOCK TABLES `Disciplina` WRITE;
INSERT INTO `mydb`.`Disciplina` VALUES  (0,''),
 (1,'Sinais e sistemas'),
 (2,'Telefonia'),
 (3,'Eletroncia digital'),
 (4,'Eletromagnetismo'),
 (5,'Portugues');
UNLOCK TABLES;
/*!40000 ALTER TABLE `Disciplina` ENABLE KEYS */;


--
-- Definition of table `mydb`.`Estado`
--

DROP TABLE IF EXISTS `mydb`.`Estado`;
CREATE TABLE  `mydb`.`Estado` (
  `eID` int(11) NOT NULL,
  `eNome` varchar(45) NOT NULL,
  PRIMARY KEY (`eID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `mydb`.`Estado`
--

/*!40000 ALTER TABLE `Estado` DISABLE KEYS */;
LOCK TABLES `Estado` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `Estado` ENABLE KEYS */;


--
-- Definition of table `mydb`.`Formacao`
--

DROP TABLE IF EXISTS `mydb`.`Formacao`;
CREATE TABLE  `mydb`.`Formacao` (
  `fID` int(11) NOT NULL AUTO_INCREMENT,
  `fNome` varchar(45) NOT NULL,
  PRIMARY KEY (`fID`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `mydb`.`Formacao`
--

/*!40000 ALTER TABLE `Formacao` DISABLE KEYS */;
LOCK TABLES `Formacao` WRITE;
INSERT INTO `mydb`.`Formacao` VALUES  (1,'Graduação'),
 (2,'Mestrado'),
 (3,'Doutorado');
UNLOCK TABLES;
/*!40000 ALTER TABLE `Formacao` ENABLE KEYS */;


--
-- Definition of table `mydb`.`Frequencia`
--

DROP TABLE IF EXISTS `mydb`.`Frequencia`;
CREATE TABLE  `mydb`.`Frequencia` (
  `feID` int(11) NOT NULL AUTO_INCREMENT,
  `feData` varchar(45) NOT NULL,
  `feFalta` int(11) NOT NULL,
  `feMatricula` int(11) NOT NULL,
  PRIMARY KEY (`feID`),
  KEY `fk_Frequencia_Matricula1` (`feMatricula`),
  CONSTRAINT `fk_Frequencia_Matricula1` FOREIGN KEY (`feMatricula`) REFERENCES `Matricula` (`mID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `mydb`.`Frequencia`
--

/*!40000 ALTER TABLE `Frequencia` DISABLE KEYS */;
LOCK TABLES `Frequencia` WRITE;
INSERT INTO `mydb`.`Frequencia` VALUES  (1,'12/10/2001',12102001,4),
 (2,'20101211',1,10),
 (3,'123454',2,8);
UNLOCK TABLES;
/*!40000 ALTER TABLE `Frequencia` ENABLE KEYS */;


--
-- Definition of table `mydb`.`Matricula`
--

DROP TABLE IF EXISTS `mydb`.`Matricula`;
CREATE TABLE  `mydb`.`Matricula` (
  `mID` int(11) NOT NULL AUTO_INCREMENT,
  `mAluno` int(11) NOT NULL,
  `mTurma` int(11) NOT NULL,
  PRIMARY KEY (`mID`),
  KEY `fk_Matricula_Aluno` (`mAluno`),
  KEY `fk_Matricula_Turma1` (`mTurma`),
  KEY `mAluno_aID` (`mAluno`),
  KEY `mTurma_tID` (`mTurma`),
  CONSTRAINT `mAluno_aID` FOREIGN KEY (`mAluno`) REFERENCES `Aluno` (`aID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `mTurma_tID` FOREIGN KEY (`mTurma`) REFERENCES `Turma` (`tID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `mydb`.`Matricula`
--

/*!40000 ALTER TABLE `Matricula` DISABLE KEYS */;
LOCK TABLES `Matricula` WRITE;
INSERT INTO `mydb`.`Matricula` VALUES  (4,1,5),
 (5,3,5),
 (6,4,7),
 (7,5,7),
 (8,6,9),
 (9,7,9),
 (10,2,11);
UNLOCK TABLES;
/*!40000 ALTER TABLE `Matricula` ENABLE KEYS */;


--
-- Definition of table `mydb`.`Professor`
--

DROP TABLE IF EXISTS `mydb`.`Professor`;
CREATE TABLE  `mydb`.`Professor` (
  `pID` int(11) NOT NULL AUTO_INCREMENT,
  `pNome` varchar(45) NOT NULL,
  `pCpf` varchar(45) NOT NULL,
  `pFormacao` int(11) NOT NULL,
  PRIMARY KEY (`pID`),
  KEY `fk_Professor_Formação1` (`pFormacao`),
  CONSTRAINT `fk_Professor_Formação1` FOREIGN KEY (`pFormacao`) REFERENCES `Formacao` (`fID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `mydb`.`Professor`
--

/*!40000 ALTER TABLE `Professor` DISABLE KEYS */;
LOCK TABLES `Professor` WRITE;
INSERT INTO `mydb`.`Professor` VALUES  (0,'','',1),
 (1,'mario','1111',3),
 (2,'Pedro','234534534',1),
 (3,'nilton','123123',2),
 (4,'Marcio','123123',3),
 (5,'fabio','12345',2),
 (6,'mello','12125677832',2),
 (7,'Jones William Martins','00444276971',1);
UNLOCK TABLES;
/*!40000 ALTER TABLE `Professor` ENABLE KEYS */;


--
-- Definition of table `mydb`.`Turma`
--

DROP TABLE IF EXISTS `mydb`.`Turma`;
CREATE TABLE  `mydb`.`Turma` (
  `tID` int(11) NOT NULL AUTO_INCREMENT,
  `tProfessor` int(11) NOT NULL,
  `tdisciplina` int(11) NOT NULL,
  `tNum` int(11) DEFAULT NULL,
  PRIMARY KEY (`tID`),
  KEY `tDisciplina_dID` (`tdisciplina`),
  KEY `tProfessor_pID` (`tProfessor`),
  CONSTRAINT `tDisciplina_dID` FOREIGN KEY (`tdisciplina`) REFERENCES `Disciplina` (`dID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `tProfessor_pID` FOREIGN KEY (`tProfessor`) REFERENCES `Professor` (`pID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `mydb`.`Turma`
--

/*!40000 ALTER TABLE `Turma` DISABLE KEYS */;
LOCK TABLES `Turma` WRITE;
INSERT INTO `mydb`.`Turma` VALUES  (5,1,2,112211),
 (6,2,3,112211),
 (7,3,4,112222),
 (8,4,2,112222),
 (9,4,2,112233),
 (10,5,5,112233),
 (11,6,5,20101201);
UNLOCK TABLES;
/*!40000 ALTER TABLE `Turma` ENABLE KEYS */;




/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
