
package cadastro;

import UtilDB.Aluno;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;

public class TelaAluno extends javax.swing.JFrame {

    private Connection conexao;

    public TelaAluno(java.awt.Frame parent, boolean modal) {
        //Cria os objetos da tela
        initComponents();
        this.setLocationRelativeTo(null);
        // Inicializa da tabela.
        inicializaTabela();
    }
  
    public List<Aluno> listarAlunos() {
        //Cria uma instancia do objeto arrayLis = lst
        List lst = new ArrayList();
        // Recupera todos os alunos cadastrados no banco de dados.
        String sql = "SELECT * FROM Aluno a";
        try {
            // Cria uma instância da classe Conexao e invoca o método obterConexao.
            Connection cone=new Conexao().obterConexao();;
            PreparedStatement st = cone.prepareStatement(sql);
            ResultSet rs = st.executeQuery();
            while (rs.next()) {
                //Cria uma instancia da classe aluno
                Aluno aluno = new Aluno ();
                //Seta o nome do objeto aluno, passando como parametro o campo da tabela aluno do BD.
                aluno.setNome(rs.getString("aNome"));
                //Seta o id do objeto aluno, passando como parametro o campo da tabela aluno do BD.
                aluno.setId(rs.getInt("aID"));
                // Seta o cpf do objeto aluno.
                aluno.setCpf(rs.getString("aCpf"));
                // Adiciona o objeto aluno no arraylist "lst".
                lst.add(aluno);
            }
                
            st.close();
            rs.close();
            //Imprimi no console a mensagem entre aspas.
            System.out.println("Alunos listadas com sucesso.");


        } catch (SQLException ex) {
            System.err.println("Erro ao listar : Alunos" + ex.toString());
        }
        return lst;
    }

  
    // Método reponsável por inicializar a tabela.
    private void inicializaTabela(){
      // Cria uma instancia de DefaultTableModel.
      DefaultTableModel modelo = (DefaultTableModel) jTAluno.getModel();
      //Limpa a lista
      while (modelo.getRowCount() > 0) {
            modelo.removeRow(0);
        }
        List lst=listarAlunos();
        for (int x=0; x<lst.size();x++) {
            // Faz um typeCast dizendo que a lista "lst" é do tipo Aluno.
           Aluno aluno = (Aluno) lst.get(x);
           //Cria uma instancia do objeto vetor
            String vetor[] = new String[3];
            vetor[0] = aluno.getId()+"";
            vetor[1] = aluno.getCpf();
            vetor[2] = aluno.getNome();
           //Adiciona uma nova linha a instância do objeto DefaulTableModel
           // Adiciona uma nova linha da tabela.
           modelo.addRow(vetor);
        }

    }

    // Método responsável por cadastrar um novo aluno.
    public void cadastrar(Aluno aluno) throws SQLException {
        
        //Cria uma nova instancia da classe Conexao.
        conexao = new Conexao().obterConexao();
        // Sql responsável por realizar a inserção de um novo aluno no BD.
        String sql = "INSERT INTO Aluno (aNome,aCpf) VALUES (?,?)";
        try {
            PreparedStatement st = conexao.prepareStatement(sql);
            //seta o string, passando como parametro o atributo nome do objeto aluno.
            st.setString(1, aluno.getNome());
            //seta o string, passando como paramentro o atributo o cpf do objeto aluno.
            st.setString(2, aluno.getCpf());
            st.execute();
            st.close();
            //Imprimi no console a mensagem entre aspas.
            System.out.println("Inserido com sucesso");
        } catch (SQLException ex) {
            //Imprimi no console a mensagem entre aspas.
            System.err.println("Erro ao inserir: " + ex.toString());
        }
        //Encerra conexão com banco de dados.
        conexao.close();
    }
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jTFNome = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jTFCpf = new javax.swing.JTextField();
        jBCadastrar = new javax.swing.JButton();
        jBCancelar = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTAluno = new javax.swing.JTable();

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(jTable1);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Cadastro de Alunos", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("DejaVu Sans", 1, 12))); // NOI18N

        jLabel1.setText("Nome:");

        jTFNome.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTFNomeActionPerformed(evt);
            }
        });

        jLabel3.setText("CPF:");

        jBCadastrar.setText("Cadastrar");
        jBCadastrar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBCadastrarActionPerformed(evt);
            }
        });

        jBCancelar.setText("Cancelar");
        jBCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(jLabel1)
                .addGap(18, 18, 18)
                .addComponent(jTFNome, javax.swing.GroupLayout.PREFERRED_SIZE, 264, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(139, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jBCancelar)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addGap(33, 33, 33)
                        .addComponent(jTFCpf, javax.swing.GroupLayout.PREFERRED_SIZE, 155, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(138, 138, 138)
                        .addComponent(jBCadastrar)))
                .addGap(23, 23, 23))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel1)
                            .addComponent(jTFNome, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel3)
                            .addComponent(jTFCpf, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addContainerGap(22, Short.MAX_VALUE)
                        .addComponent(jBCadastrar)
                        .addGap(15, 15, 15)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jBCancelar)
                .addContainerGap())
        );

        jTAluno.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "ID", "CPF", "NOME"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane2.setViewportView(jTAluno);
        jTAluno.getColumnModel().getColumn(0).setMaxWidth(50);
        jTAluno.getColumnModel().getColumn(1).setPreferredWidth(5);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 452, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(32, 32, 32)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 91, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(23, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(61, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jTFNomeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTFNomeActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTFNomeActionPerformed

    private void jBCadastrarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBCadastrarActionPerformed
        // Verifica se o campo nome e cpf da tela estão  vazios
        if ((jTFNome.getText().equals("")) || (jTFCpf.getText().equals(""))) {
            // Joga mensagem na tela informando que estão faltando dados.
            JOptionPane.showMessageDialog(null, "Faltando Dados");
        } else {
            //Cria uma nova instancia do objeto aluno.
            Aluno aluno = new Aluno();
            //seta no objeto aluno, o cpf digitado na tela.
            aluno.setCpf(jTFCpf.getText());
            //seta no objeto aluno o nome digitado na tela.
            aluno.setNome(jTFNome.getText());

            try {
                this.cadastrar(aluno);
                //limpa os campos nome e cpf da tela.
                jTFNome.setText("");
                jTFCpf.setText("");
                // Atualiza a tabela
                this.inicializaTabela();
            } catch (SQLException ex) {
                Logger.getLogger(TelaAluno.class.getName()).log(Level.SEVERE, null, ex);
            }

        }

    }//GEN-LAST:event_jBCadastrarActionPerformed

    private void jBCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBCancelarActionPerformed
        // Sai da tela atual.
        this.dispose();
    }//GEN-LAST:event_jBCancelarActionPerformed
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton jBCadastrar;
    private javax.swing.JButton jBCancelar;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTable jTAluno;
    private javax.swing.JTextField jTFCpf;
    private javax.swing.JTextField jTFNome;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables
}
