package cadastro;

import UtilDB.Disciplina;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;

public class TelaDisciplina extends javax.swing.JFrame {

    private Connection conexao;

    public TelaDisciplina(java.awt.Frame parent, boolean modal) {
       // metodo construtor da Tela disciplina
        initComponents();
        this.setLocationRelativeTo(null);
        // Inicializa Tabela
        this.inicializaTabela();
        
    }

    public void cadastrar(Disciplina disciplina) throws SQLException {
        // Inseri valores no banco na tabela Discipina coluna dNome
        conexao = new Conexao().obterConexao();
        String sql = "INSERT INTO Disciplina (dNome) VALUES (?)";
        try {
            PreparedStatement st = conexao.prepareStatement(sql);
            // 1 indica seguencia da colunas
            st.setString(1, disciplina.getDnome());
            st.execute();
            st.close();

            System.out.println("Inserido com sucesso");

        } catch (SQLException ex) {
            System.err.println("Erro ao inserir: " + ex.toString());
        }
        // Fecha conexão
        conexao.close();
    }

    public List<Disciplina> listarDisciplina() {

        // Resgata valores do banco na tabela disciplina "d" apelido
        List lst = new ArrayList();
               String sql = "SELECT * FROM Disciplina d";
        try {
            Connection cone = new Conexao().obterConexao();
            PreparedStatement st = cone.prepareStatement(sql);
            ResultSet rs = st.executeQuery();
            while (rs.next()) {
                Disciplina disciplina = new Disciplina ();
                disciplina.setDnome(rs.getString("dNome"));
                disciplina.setDid(rs.getInt("dID"));

                lst.add(disciplina);
            }

            st.close();
            rs.close();
            System.out.println("Disciplinas listadas com sucesso.");


        } catch (SQLException ex) {
            System.err.println("Erro ao listar disciplinas:" + ex.toString());
        }
        return lst;
    }



    private void inicializaTabela(){
      // inicializa tabela  e lista valores do banco
      DefaultTableModel modelo = (DefaultTableModel) jTDisciplina.getModel();
      //Limpa a lista
      while (modelo.getRowCount() > 0) {
            modelo.removeRow(0);
        }
        List lst =new ArrayList();
        lst=listarDisciplina();
        for (int x=0; x<lst.size();x++) {
           Disciplina professor = (Disciplina) lst.get(x);
            String vetor[] = new String[2];
            vetor[0] = professor.getDid()+"";
            vetor[1] = professor.getDnome();
           modelo.addRow(vetor);
        }

    }
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jTFDisciplina = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jBCadastrar = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTDisciplina = new javax.swing.JTable();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jTFDisciplina.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTFDisciplinaActionPerformed(evt);
            }
        });

        jLabel1.setText("Disciplina:");

        jBCadastrar.setText("Cadastrar");
        jBCadastrar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBCadastrarActionPerformed(evt);
            }
        });

        jButton2.setText("Cancelar");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jTDisciplina.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "ID", "DISCIPLINA"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(jTDisciplina);
        jTDisciplina.getColumnModel().getColumn(0).setMaxWidth(50);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 317, Short.MAX_VALUE)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jBCadastrar)
                                .addGap(18, 18, 18)
                                .addComponent(jButton2))
                            .addComponent(jTFDisciplina, javax.swing.GroupLayout.PREFERRED_SIZE, 241, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jTFDisciplina, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jBCadastrar)
                    .addComponent(jButton2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 18, Short.MAX_VALUE)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 120, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jTFDisciplinaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTFDisciplinaActionPerformed
    }//GEN-LAST:event_jTFDisciplinaActionPerformed

    private void jBCadastrarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBCadastrarActionPerformed
        // Faz verificão de campo vazio
        if ((jTFDisciplina.getText().equals(""))) {
            JOptionPane.showMessageDialog(null, "Faltando Dados");
        } else {
            // inseri valor  e inicializa tabela
            try {
                Disciplina disciplina = new Disciplina();
                disciplina.setDnome(jTFDisciplina.getText());
                this.cadastrar(disciplina);
                jTFDisciplina.setText("");
                this.inicializaTabela();
            } catch (SQLException ex) {
                Logger.getLogger(TelaDisciplina.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }//GEN-LAST:event_jBCadastrarActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        this.dispose();
    }//GEN-LAST:event_jButton2ActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBCadastrar;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTDisciplina;
    private javax.swing.JTextField jTFDisciplina;
    // End of variables declaration//GEN-END:variables
}
