

package cadastro;
import UtilDB.Aluno;
import UtilDB.Matricula;
import UtilDB.Turma;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;
import javax.swing.table.DefaultTableModel;

public class TelaMatricula extends javax.swing.JFrame {

    private Connection conexao;

    // metodo contrutor da tela matricula
    public TelaMatricula(java.awt.Frame parent, boolean modal) {
        initComponents();
        this.setLocationRelativeTo(null);
        conexao = new Conexao().obterConexao();
        this.listarTurmas();
        this.listarAlunos();
        this.inicializaTabela();
    }

    public List<Matricula> listarMatricula() {
        List lst = new ArrayList();
        // Select na tabela matricula aluno turma
               String sql = "SELECT * FROM Matricula m, Aluno a, Turma t"
                       + "   WHERE m.mAluno = a.aID "
                       + "     AND m.mTurma = t.tID"
                       + " ORDER BY m.mTurma, m.mAluno";
        try {
            Connection cone=new Conexao().obterConexao();
            PreparedStatement st = cone.prepareStatement(sql);
            ResultSet rs = st.executeQuery();
            while (rs.next()) {
                Matricula matricula = new Matricula ();                                
                matricula.getAluno().setNome(rs.getString("aNome"));
                matricula.getTurma().setTnum(rs.getInt("tNum"));
                lst.add(matricula);
            }

            st.close();
            rs.close();
            System.out.println("Matriculas listadas com sucesso.");


        } catch (SQLException ex) {
            System.err.println("Erro ao listar matriculas:" + ex.toString());
        }
        return lst;
    }



    private void inicializaTabela(){
      DefaultTableModel modelo = (DefaultTableModel) jTMatricula.getModel();
      //Limpa a lista
      while (modelo.getRowCount() > 0) {
            modelo.removeRow(0);
        }
        List lst=listarMatricula();
        for (int x=0; x<lst.size();x++) {
           Matricula matricula = (Matricula) lst.get(x);
            String vetor[] = new String[2];
            vetor[0] = matricula.getTurma().getTnum()+"";
            vetor[1] = matricula.getAluno().getNome();
           modelo.addRow(vetor);
        }

    }

    private void matricular(Aluno aluno) {
        conexao = new Conexao().obterConexao();
        // insere valores na tabela matricula
        String sql = "INSERT INTO Matricula (mTurma,mAluno) VALUES (?,?)";

        try {
            

            PreparedStatement st = conexao.prepareStatement(sql);
            
            st.setInt(1, aluno.getTurma().getTid());
            st.setInt(2, aluno.getId());
            st.execute();
            st.close();

            System.out.println("Aluno matriculado com sucesso.");

        } catch (SQLException ex) {
            System.err.println("Erro ao matricular aluno: " + ex.toString());
        }
    }

    public void listarAlunos() {
        jCBAluno.removeAllItems();
       // Faz a listagem na tabela aluno por ordem
        String sql = "SELECT * FROM Aluno order by anome ";
        try {
            PreparedStatement st = conexao.prepareStatement(sql);
            ResultSet rs = st.executeQuery();

            while (rs.next() == true) {
                Aluno aluno = new Aluno();
                aluno.setId(rs.getInt("aid"));
                aluno.setNome(rs.getString("aNome"));
                
                jCBAluno.addItem(aluno);

            }
            st.close();
            rs.close();
            System.out.println("Alunos listados com sucesso!");

        } catch (SQLException ex) {
            System.err.println("Erro ao listar alunos: " + ex.toString());
        }


    }

    public void listarTurmas() {
        // Faz listagem da tabela turma ordenado por tnum
        String sql = "SELECT * FROM Turma t group by tnum";
        jCBTurma.removeAllItems();
        
        try {
            PreparedStatement st = conexao.prepareStatement(sql);
            ResultSet rs = st.executeQuery();
            int i=0;
            while (rs.next() == true) {
                Turma turma = new Turma();
                turma.setTid(rs.getInt("tid"));
                turma.setTnum(Integer.parseInt(rs.getString("tNum")));
               
                
                jCBTurma.addItem(turma);
               
            }
            st.close();
            rs.close();
            System.out.println("Turmas listadas com sucesso.");

        } catch (SQLException ex) {
            System.err.println("Erro ao listar turmas: " + ex.toString());
        }
    }
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jCBAluno = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        jButton2 = new javax.swing.JButton();
        jCBTurma = new javax.swing.JComboBox();
        jBMatricular = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTMatricula = new javax.swing.JTable();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jLabel1.setText("Aluno:");

        jCBAluno.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        jLabel2.setText("Turma:");

        jButton2.setText("Cancelar");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jCBTurma.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        jBMatricular.setText("Matricular");
        jBMatricular.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBMatricularActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 163, Short.MAX_VALUE)
        );

        jTMatricula.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "TURMA", "ALUNO"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(jTMatricula);
        jTMatricula.getColumnModel().getColumn(0).setPreferredWidth(50);
        jTMatricula.getColumnModel().getColumn(1).setPreferredWidth(150);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(410, 410, 410))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabel1)
                                .addGap(18, 18, 18)
                                .addComponent(jCBAluno, javax.swing.GroupLayout.PREFERRED_SIZE, 211, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabel2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jCBTurma, 0, 241, Short.MAX_VALUE)))
                        .addGap(37, 37, 37)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jBMatricular)
                            .addComponent(jButton2)))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 404, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jCBAluno, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jBMatricular))
                .addGap(26, 26, 26)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jCBTurma, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton2))
                .addGap(32, 32, 32)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(36, 36, 36)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 238, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jBMatricularActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBMatricularActionPerformed
        Aluno aluno = new Aluno();
        aluno=(Aluno)jCBAluno.getSelectedItem();
        aluno.setTurma((Turma) jCBTurma.getSelectedItem());       
        this.matricular(aluno);
        this.inicializaTabela();
    }//GEN-LAST:event_jBMatricularActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        this.dispose();
    }//GEN-LAST:event_jButton2ActionPerformed

    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBMatricular;
    private javax.swing.JButton jButton2;
    private javax.swing.JComboBox jCBAluno;
    private javax.swing.JComboBox jCBTurma;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTMatricula;
    // End of variables declaration//GEN-END:variables

}
