package cadastro;

import UtilDB.Disciplina;
import UtilDB.Professor;
import UtilDB.Turma;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;

public class TelaTurma extends javax.swing.JFrame {

    private Connection conexao;

    public TelaTurma(java.awt.Frame parent, boolean modal) {
        initComponents();
        this.setLocationRelativeTo(null);
        conexao = new Conexao().obterConexao();
        this.listarDisciplinas();
        this.listarProfessores();
        inicializaTabela();
    }

    public List<Turma> listarTurma() {
       // select na tabela turma professor disciplina
        List lst = new ArrayList();
               String sql = "SELECT t.tNum, p.pNome, d.dNome "
                       + "   FROM Turma t, Professor p, Disciplina d"
                       + "   WHERE t.tProfessor = p.pID"
                       + "     AND t.tDisciplina = d.dID"
                       + " ORDER BY t.tNum";
        try {
            Connection cone=new Conexao().obterConexao();
            PreparedStatement st = cone.prepareStatement(sql);
            ResultSet rs = st.executeQuery();
            while (rs.next()) {
                Turma turma = new Turma ();
                turma.setTnum(rs.getInt("tNum"));
                turma.getProfessor().setPnome(rs.getString("pNome"));
                turma.getDisciplina().setDnome(rs.getString("dNome"));
                lst.add(turma);

            }

            st.close();
            rs.close();
            System.out.println("Alunos listadas com sucesso.");


        } catch (SQLException ex) {
            System.err.println("Erro ao listar : Alunos" + ex.toString());
        }
        return lst;
    }



    private void inicializaTabela(){
      DefaultTableModel modelo = (DefaultTableModel) jTTurma.getModel();
      //Limpa a lista
      while (modelo.getRowCount() > 0) {
            modelo.removeRow(0);
        }
        List lst=listarTurma();
        for (int x=0; x<lst.size();x++) {
           Turma turma = (Turma) lst.get(x);
            String vetor[] = new String[3];
            vetor[0] = turma.getTnum()+"";
            vetor[1] = turma.getProfessor().getPnome()+"";
            vetor[2] = turma.getDisciplina().getDnome()+"";
           modelo.addRow(vetor);
        }

    }

    private void cadastrar(Turma turma) {
        conexao = new Conexao().obterConexao();
        String sql = "INSERT INTO Turma (tNum,tDisciplina,tProfessor) VALUES (?,?,?)";

        try {

            PreparedStatement st = conexao.prepareStatement(sql);
            st.setInt(1, turma.getTnum());
            st.setInt(2, turma.getDisciplina().getDid());
            st.setInt(3, turma.getProfessor().getPid());
            st.execute();
            st.close();
            

            System.out.println("Turma cadastrada com sucesso.");
        } catch (SQLException ex) {
            System.err.println("Erro ao cadastrar turma: " + ex.toString());
        }

    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jTFTurma = new javax.swing.JTextField();
        jBCadastrar = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jCBProfessor = new javax.swing.JComboBox();
        jCBDisciplina = new javax.swing.JComboBox();
        jLabel3 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTTurma = new javax.swing.JTable();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jLabel1.setText("Turma:");

        jBCadastrar.setText("Cadastrar");
        jBCadastrar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBCadastrarActionPerformed(evt);
            }
        });

        jButton2.setText("Cancelar");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jCBProfessor.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        jCBDisciplina.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        jLabel3.setText("Disciplina:");

        jLabel2.setText("Professor:");

        jTTurma.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "TURMA", "PROFESSOR", "DISCIPLINA"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, true
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(jTTurma);
        jTTurma.getColumnModel().getColumn(0).setMaxWidth(100);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 452, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel3)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jCBDisciplina, javax.swing.GroupLayout.PREFERRED_SIZE, 178, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel2)
                                    .addComponent(jLabel1))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jTFTurma, javax.swing.GroupLayout.DEFAULT_SIZE, 178, Short.MAX_VALUE)
                                    .addComponent(jCBProfessor, 0, 178, Short.MAX_VALUE))))
                        .addGap(38, 38, 38)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jBCadastrar)
                            .addComponent(jButton2))
                        .addGap(107, 107, 107))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jBCadastrar)
                    .addComponent(jTFTurma, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(16, 16, 16)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel2)
                            .addComponent(jCBProfessor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel3)
                            .addComponent(jCBDisciplina, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addComponent(jButton2)))
                .addGap(18, 18, 18)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 133, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jBCadastrarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBCadastrarActionPerformed
        if ((jTFTurma.getText().equals(""))) {
            JOptionPane.showMessageDialog(null, "Faltando Dados");
        } else {
            Turma turma = new Turma();
            turma.setTnum(Integer.parseInt(jTFTurma.getText()));
            turma.setProfessor((Professor) jCBProfessor.getSelectedItem());
            turma.setDisciplina((Disciplina) jCBDisciplina.getSelectedItem());
            this.cadastrar(turma);
            inicializaTabela();
        }
    }//GEN-LAST:event_jBCadastrarActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        this.dispose();
    }//GEN-LAST:event_jButton2ActionPerformed

    public void listarDisciplinas() {
        jCBDisciplina.removeAllItems();
        String sql = "SELECT * FROM Disciplina d";
        try {
            PreparedStatement st = conexao.prepareStatement(sql);
            ResultSet rs = st.executeQuery();

            while (rs.next() == true) {
                Disciplina disciplina = new Disciplina();
                disciplina.setDid(rs.getInt("did"));
                disciplina.setDnome(rs.getString("dNome"));

                jCBDisciplina.addItem(disciplina);

            }
            st.close();
            rs.close();
            System.out.println("Diciplinas listadas com sucesso!");

        } catch (SQLException ex) {
            System.err.println("Erro ao listar disciplinas: " + ex.toString());
        }


    }

    public void listarProfessores() {

        String sql = "SELECT * FROM Professor p";
        jCBProfessor.removeAllItems();

        try {
            PreparedStatement st = conexao.prepareStatement(sql);
            ResultSet rs = st.executeQuery();

            while (rs.next() == true) {
                Professor professor = new Professor();
                professor.setPid(rs.getInt("pid"));
                professor.setPnome(rs.getString("pNome"));
                jCBProfessor.addItem(professor);
            }
            st.close();
            rs.close();
            System.out.println("Professores listados com sucesso.");

        } catch (SQLException ex) {
            System.err.println("Erro ao listar professores: " + ex.toString());
        }
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBCadastrar;
    private javax.swing.JButton jButton2;
    private javax.swing.JComboBox jCBDisciplina;
    private javax.swing.JComboBox jCBProfessor;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField jTFTurma;
    private javax.swing.JTable jTTurma;
    // End of variables declaration//GEN-END:variables
}
